"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// Polyfill fetch
require("isomorphic-unfetch");
var _apolloClient;
var ssrMode = !process.browser;
function initApollo(client, options) {
    if (!client) {
        throw new Error('[client] param is missing and is required to get the ApolloClient');
    }
    if (ssrMode) {
        return getClient(client, options);
    }
    if (!_apolloClient) {
        _apolloClient = getClient(client, options);
    }
    return _apolloClient;
}
exports.default = initApollo;
function getClient(client, options) {
    if (options === void 0) { options = {}; }
    if (typeof client === 'function') {
        client = client(options);
    }
    if (options.initialState)
        client.cache.restore(options.initialState);
    return client;
}
//# sourceMappingURL=apollo.js.map